import serial
import time
import msvcrt

ser = serial.Serial("COM7", 57600) #Serial Port on COM3, 57600 Baud

strings = ['0', 'E|', 'B|', 'G|', 'D|', 'A|', 'E|'] #the 0 to simplify zero-indexing
                                                    #Each value in array is a line of text
last_state = 0 #Previous states
last_fret = 0
last_string = 0
last_time = time.clock() #Time of the last note played
curr_time = time.clock() #Time of the current note played

while True:
    if len(strings[1]) > 165:
        strings = ['0', 'E|', 'B|', 'G|', 'D|', 'A|', 'E|']
    ser.flushInput() #Clear the Buffer to prevent frame shift errors

    val1 = ser.readline() #3 serial bytes
    val2 = ser.readline()
    val3 = ser.readline()
    for value in [val1, val2, val3]:
        if value[0] == 's':                 #S Indicates String Information
            curr_string = int(value[1])
        elif value[0] == 'f':               #F indicates fret information
            if value[1] != "1":
                curr_fret = int(value[1])   
            else:
                if len(value) > 4:          #Deal with 2 digit fret numbers
                    curr_fret = (10*int(value[1])) + int(value[2])
                else:
                    curr_fret = int(value[1])
                    
        elif value[0] == 'n':               #If note is being turned on or not (state)
            curr_state = int(value[1])
            curr_time = time.clock() #Record time of note turning on
        else:
            curr_state = 0
    if curr_state == 1: 
        if curr_fret > 9:
            appender = '---' #two digit fret, add extra dash to other strings 
        else: appender = '--' 
        
        if not ((curr_string == last_string) and (curr_fret == last_fret)): #add either dashes or fret number
            print (curr_time - last_time)
            for i in range(1,7):
                
                if (curr_time - last_time) > 0.2: #Not a chord (0.2 seconds is threshold for chord)
                    if i == curr_string:
                        strings[i]+=str(curr_fret) + "-" #Add dashes or proper fret name
                    else: strings[i]+=appender
                else:
                    if i == curr_string: #For a chord, add it at the same time
                        if curr_fret > 9:
                            strings[i] = strings[i][0:-3] #Take out last 3 characters and replace them with fret information
                            strings[i] += str(curr_fret) + "-"
                        else:
                            strings[i] = strings[i][0:-2] #Only take out 2 characters if it's a single digit fret
                            strings[i] += str(curr_fret) + "-"
                            
                print strings[i]
            last_time = curr_time
            print ''   #Add in an extra line for clarity
             

    last_string = curr_string
    last_fret = curr_fret

    if msvcrt.kbhit(): #kit any key to stop
        break

ser.close() #make sure to close the serial port
